<?php
declare(strict_types=1);

namespace Neos\Flow\Persistence\Doctrine\Migrations;

use Doctrine\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;

class Version20190411184935 extends AbstractMigration
{
    public function getDescription(): string
    {
        return 'Remove primary key on Edge, as it improves ForkContentStream performance by factor 2';
    }

    public function up(Schema $schema)
    {
        $this->abortIf($this->connection->getDatabasePlatform()->getName() != 'mysql',
            'Migration can only be executed safely on "mysql".');
        $this->addSql('ALTER TABLE `neos_contentgraph_hierarchyrelation` DROP PRIMARY KEY');
    }

    public function down(Schema $schema)
    {
        $this->abortIf($this->connection->getDatabasePlatform()->getName() != 'mysql',
            'Migration can only be executed safely on "mysql".');

        throw new \RuntimeException('Not supported.');
    }
}
